package cpcns.utils;

import cpcns.utils.PrintStream;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

public class ConvertVideo {

   private static String inputPath = "";
   private static String outputPath = "";
   private static String ffmpegPath = "";


   public static void main(String[] args) throws IOException {
      getPath();
      if(!checkfile(inputPath)) {
         System.out.println(inputPath + " is not file");
      } else {
         if(process()) {
            System.out.println("ok");
         }

      }
   }

   public static void getPath() {
      File diretory = new File("");

      try {
         String e = diretory.getAbsolutePath();
         inputPath = "E:\\1.MP4";
         outputPath = "E:\\vod\\";
         ffmpegPath = "E:\\ConvertVideo\\ffmpeg1\\";
         System.out.println(e);
      } catch (Exception var2) {
         System.out.println("getPath出错");
      }

   }

   public static boolean process() {
      int type = checkContentType();
      boolean status = false;
      System.out.println("直接转成mp4格式");
      status = processMp4(inputPath);
      return status;
   }

   private static int checkContentType() {
      String type = inputPath.substring(inputPath.lastIndexOf(".") + 1, inputPath.length()).toLowerCase();
      return type.equals("avi")?0:(type.equals("mpg")?0:(type.equals("wmv")?0:(type.equals("3gp")?0:(type.equals("mov")?0:(type.equals("mp4")?0:(type.equals("asf")?0:(type.equals("asx")?0:(type.equals("flv")?0:(type.equals("wmv9")?1:(type.equals("rm")?1:(type.equals("rmvb")?1:9)))))))))));
   }

   private static boolean checkfile(String path) {
      File file = new File(path);
      return file.isFile();
   }

   private static String processAVI(int type) {
      ArrayList commend = new ArrayList();
      commend.add(ffmpegPath + "mencoder");
      commend.add(inputPath);
      commend.add("-oac");
      commend.add("lavc");
      commend.add("-lavcopts");
      commend.add("acodec=mp3:abitrate=64");
      commend.add("-ovc");
      commend.add("xvid");
      commend.add("-xvidencopts");
      commend.add("bitrate=600");
      commend.add("-of");
      commend.add("mp4");
      commend.add("-o");
      commend.add(outputPath + "a.AVI");

      try {
         ProcessBuilder e = new ProcessBuilder(new String[0]);
         Process process = e.command(commend).redirectErrorStream(true).start();
         new PrintStream(process.getInputStream());
         new PrintStream(process.getErrorStream());
         process.waitFor();
         return outputPath + "a.AVI";
      } catch (Exception var4) {
         var4.printStackTrace();
         return null;
      }
   }

   private static boolean processFlv(String oldfilepath) {
      if(!checkfile(inputPath)) {
         System.out.println(oldfilepath + " is not file");
         return false;
      } else {
         ArrayList command = new ArrayList();
         command.add(ffmpegPath + "ffmpeg");
         command.add("-i");
         command.add(oldfilepath);
         command.add("-ab");
         command.add("56");
         command.add("-ar");
         command.add("22050");
         command.add("-qscale");
         command.add("8");
         command.add("-r");
         command.add("15");
         command.add("-s");
         command.add("600x500");
         command.add(outputPath + "a.flv");

         try {
            Process e = (new ProcessBuilder(command)).redirectErrorStream(true).start();
            (new PrintStream(e.getErrorStream())).start();
            (new PrintStream(e.getInputStream())).start();
            e.waitFor();
            return true;
         } catch (Exception var3) {
            var3.printStackTrace();
            return false;
         }
      }
   }

   private static boolean processMp4(String oldfilepath) {
      if(!checkfile(inputPath)) {
         System.out.println(oldfilepath + " is not file");
         return false;
      } else {
         ArrayList command = new ArrayList();
         command.add(ffmpegPath + "ffmpeg");
         command.add("-i");
         command.add(oldfilepath);
         command.add("-c:v");
         command.add("libx264");
         command.add("-mbd");
         command.add("0");
         command.add("-c:a");
         command.add("aac");
         command.add("-strict");
         command.add("-2");
         command.add("-pix_fmt");
         command.add("yuv420p");
         command.add("-movflags");
         command.add("faststart");
         command.add(outputPath + "a.mp4");

         try {
            Process e = (new ProcessBuilder(command)).redirectErrorStream(true).start();
            (new PrintStream(e.getErrorStream())).start();
            (new PrintStream(e.getInputStream())).start();
            e.waitFor();
            return true;
         } catch (Exception var3) {
            var3.printStackTrace();
            return false;
         }
      }
   }
}
